require 'tk'
require 'zlib'

#
# This application retrieves a list of checkboxes from an XML file. User is allowed to select from that list
# the set of checkboxes to control. User can select more than one set and each set can vary in length, and
# the minimum set size is two checkboxes.
#

#
# #########################################################
#
# Message Box section:
#

require 'Win32API'

#
# Button styles:
#
$MB_OK = 0
$MB_OKCANCEL = 1
$MB_ABORTRETRYIGNORE = 2
$MB_YESNOCANCEL = 3
$MB_YESNO = 4
$MB_RETRYCANCEL = 5

#
# Icon styles:
#
$MB_ICONHAND = 16
$MB_ICONQUESTION = 32
$MB_ICONEXCLAMATION = 48
$MB_ICONASTERISK = 64

#
# Default button:
#
$MB_DEFBUTTON1 = 0
$MB_DEFBUTTON2 = 256
$MB_DEFBUTTON3 = 512

#
# Return values:
#
$IDOK = 1
$IDCANCEL = 2
$IDABORT = 3
$IDRETRY = 4
$IDIGNORE = 5
$IDYES = 6
$IDNO = 7

def messageBox(message, title = 'Message', style = 0)
	mb = Win32API.new("user32", "MessageBox", ['L', 'P', 'P', 'L'], 'L')
	return mb.Call(0, message, title, style)
end

# Window drawing section.

root = TkRoot.new() { title "CHECKBOX CONTROL PROGRAM" }
root.geometry('+225+250')

file_name_label = TkLabel.new(root, :text=>"", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:side=>"top", :fill=>:x, :padx=>10, :pady=>10)

#
# Main frames.
#
setup_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"x", :padx=>10)

control_button_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"x", :padx=>10)

output_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"both", :expand=>true, :padx=>10, :pady=>10)

#
# list frames.
#
list_frame2 = TkFrame.new(setup_frame).pack("side"=>"left")
list_frame3 = TkFrame.new(setup_frame).pack("side"=>"left")
list_frame4 = TkFrame.new(setup_frame).pack("side"=>"left")

box_list_frame = TkFrame.new(list_frame2, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>10, "pady" =>10)
box_list_label = TkLabel.new(box_list_frame, :text=>"Check Boxes", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

box_delete_frame = TkFrame.new(box_list_frame).pack("side"=>"bottom", "pady" => 5)
box_delete_button = TkButton.new(box_delete_frame, :text=>" Select Single ", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack()

box_list_bar_vertical = TkScrollbar.new(box_list_frame).pack("side"=>"right", "fill"=>"y")
box_list = TkListbox.new(box_list_frame, "background"=>"white", "exportselection" => 0, "width"=>13, "height"=>10, :selectmode=>"extended", "font"=>"arial 10").pack("side"=>"left")
box_list.yscrollbar(box_list_bar_vertical)

set_adj_frame = TkFrame.new(list_frame3, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "pady" =>10)
set_adj_label = TkLabel.new(set_adj_frame, :text=>" Set Operations ", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

add_button = TkButton.new(set_adj_frame, :text=>"Add", :background=>"lightgrey", :foreground=>"blue", :width=>8, "font"=>"arial 10").pack(:side=>"top", :padx=>5, :pady=>10)

del_button = TkButton.new(set_adj_frame, :text=>"Delete", :background=>"lightgrey", :foreground=>"blue", :width=>8, "font"=>"arial 10").pack(:side=>"top", :padx=>5)

edit_button = TkButton.new(set_adj_frame, :text=>"Edit", :background=>"lightgrey", :foreground=>"blue", :width=>8, "font"=>"arial 10").pack(:side=>"top", :padx=>5, :pady=>10)

set_list_frame = TkFrame.new(list_frame4, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>10, "pady" =>10)
set_list_label = TkLabel.new(set_list_frame, :text=>"Check Box Sets", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

set_list_delete_frame = TkFrame.new(set_list_frame).pack("side"=>"bottom", "pady" => 5)
delete_set_list_button = TkButton.new(set_list_delete_frame, :text=>" Delete List ", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack("side"=>"bottom")

set_list_bar_vertical = TkScrollbar.new(set_list_frame).pack("side"=>"right", "fill"=>"y")
set_list_bar_horiz = TkScrollbar.new(set_list_frame, "orient"=>"hor").pack("side"=>"bottom", "fill"=>"x")

set_list = TkListbox.new(set_list_frame, :width=>55, "background"=>"white", "exportselection" => 0, "height"=>8, :selectmode=>"browse", "font"=>"arial 10").pack("side"=>"left")

set_list.yscrollbar(set_list_bar_vertical)
set_list.xscrollbar(set_list_bar_horiz)

generate_button = TkButton.new(control_button_frame, :text=>"Generate Code", :background=>"lightgrey", :foreground=>"blue", :width=>18, "font"=>"arial 10").pack(:side=>"left", :padx=>10, :pady=>5)

output_label = TkLabel.new(output_frame, :text=>"Generated Display Formatter Code - NOTE: ' Ctrl / ' selects all text.", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)
out_text_bar_vert = TkScrollbar.new(output_frame).pack("side"=>"right", "fill"=>"y")
out_text = TkText.new(output_frame, "height"=>15, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)
out_text.yscrollbar(out_text_bar_vert)

#
# Action Section:
#

#
# ###############################################################
#
# Globals:
#
cur_dir = "C:/Users/"

#
# This array holds the form boxes that are assigned a value, i.e. calculated.
#
box_array = Array.new

def process_errors(type, error, var)

	err_msg = [
		"  ERROR! The number of calculated boxes does not match the number of printed boxes.\n",
		"  ERROR! Print statement boxes do not match  -  #{var}.\n",
		"  This form has no calculations to format.\t\n"
	]

	#
	# Using bitwise operations, error is set on a bit by bit basis, where each bit represents an error message.
	#
	if (error > 0)

		mask = 1

		#
		# Math.frexp(error) returns a two element array containing the normalized fraction (a Float) and exponent
		# (a Fixnum) of error. In our case, the fraction is 0.5 and the exponent is a power of 2, as our error is 1 x 2
		# raised to 0,1,2,3,... So this returns 0.5 x 2[a power]. So, say error = 4, which is 1 x 2[2], which is the 3rd
		# error in our list. .frexp returns [0.5, 3] - we want the 3 [3rd error], we use 3 - 1 since we are starting
		# from 0 not 1. Just doing this so that I do not have to keep updating the 0.upto( ) each time I add a new error.
		#
		0.upto(Math.frexp(error)[1]-1) do |shift|
			if (((mask << shift) & error) > 0)
				messageBox(err_msg[shift], type, $MB_ICONEXCLAMATION|$MB_OK)
			end
		end
	end
end

#
# Inputs:
#
# file: The XML file that contains the boxes.
#
# Reads the XML file and returns an array of boxes that are declared in the file.
#
def build_box_array_xml(file)
#~ def build_box_array_xml(file, out_text)

	box_array = Array.new
	box = String.new

	File.open(file, "r") do |src_file|

		while (line = src_file.gets)

			if (line.delete("\s\t") =~ /^<textref="(box\d+_\d+)"/)

				box = $1

				if ($' =~ /checkbox="true"/)
#~ out_text.insert("end", "A checkbox: #{box}\n")
					box_array.push(box)
				end
			end
		end
	end
	box_array
end

def get_file_name(dir, type)

	ftypes = case (type)
			when ("RBW"): [ ["Ruby source files", '.rbw'] ]
			when ("XML"): [ ["XML files", '.xml'] ]
		end

	Tk.getOpenFile(:filetypes=>ftypes, :initialdir=>dir)
end

#
# ###############################################################
#
# Button Bindings:
#

# 
# Adds a box set to the Check Box Sets list as long as the set is not already in the list and there are no box
# intersections with other sets in the list. The addition is inserted in ascending order using the first box number
# of each set. Boxes are placed in each set in ascending order also.
#
add_button.bind("Button-1") {


}

#
# Deletes a set of checkboxes from the Check Box Sets list.
#
del_button.bind("Button-1") {

}

#
# Edits a set of checkboxes from the Check Box Sets list.
#
edit_button.bind("Button-1") {

}

generate_button.bind("Button-1") {

	#~ out_text.delete("1.0", "end")

	#
	# Check first for an empty box list:
	#
	#~ if (calc_box_array)
	if (box_array)


	box_indices_array = box_list.curselection

	set = "["

	box_indices_array.each { |x| set += "\"#{box_list.get(x)}\"," }

	set = set.chomp(",")
	set += "],"

	out_text.insert("end", set)
	

		#~ if (calc_box_array.length > 0)

			#~ #
			#~ # First create the comment block to explain what is being done:
			#~ #
			#~ t = Time.now
			#~ date = t.strftime("%m/%d/%y")
			#~ action_str = set_list.get(set_list.index("active"))

			#~ #
			#~ # First we set the comment based on the selection in the set_list:
			#~ #
			#~ if ((0..2) === set_list.index("active"))

				#~ str = "#\n# #{date}: Special $ field display code to meet jurisdiction popup caution: #{action_str}.\n# This special display code needs to be added at the end of the 'normal' calcs. The above calcs are calculated normally and we are displaying\n# those calculated values here to meet the caution. Note that the above calculations we are using here must still be formatted as per the\n# caution, that is, if the caution wants us to round a calculated result we must still round up in the main body of the calcs, we would simply\n# display those rounded values differently here.\n#\n"
			#~ else

				#~ str = "#\n# #{date}: Special $ field display code to blank all calculated fields that are equal to zero.\n# This special display code needs to be added at the end of the 'normal' calcs.\n#\n"
			#~ end

			#~ out_text.insert("end", str)

			#~ #
			#~ # Generating the format box list - we check the selection in the set_list to determine the name of the list:
			#~ #
			#~ list_type = ((0..2) === set_list.index("active") ? "format" : "blank")

			#~ str = "#{list_type}_list = %w{#{calc_box_array.join(' ')}}\n\n"
			#~ out_text.insert("end", str)

			#~ #
			#~ # Generating the formatting code for the boxes in the format_list based on Display Format selection.
			#~ #
			#~ case set_list.index("active")

				#~ when (0): str = "format_list.each do |x|\n\tcode1 = <<ENDOFSTRING1\n\tprint x, #\{x}.sub(' ','.') unless (#\{x}.empty?)\nENDOFSTRING1\n\teval(code1)\nend"

				#~ when (1): str = "format_list.each do |x|\n\tcode1 = <<ENDOFSTRING1\n\tprint x, #\{x}+' 00' unless (#\{x}.empty?)\nENDOFSTRING1\n\teval(code1)\nend"

				#~ when (2): str = "format_list.each do |x|\n\tcode1 = <<ENDOFSTRING1\n\tprint x, #\{x}+'00' unless (#\{x}.empty?)\nENDOFSTRING1\n\teval(code1)\nend"

				#~ when (3): str = "#{list_type}_list.each do |x| print x, eval(\"#\{x}.empty? ? #\{x} : #\{x}.delete(' ').to_f == 0.0 ? '' : #\{x}\") end"
			#~ end

			#~ out_text.insert("end", str)

			#~ # Set the focus to the output text window, and put the cursor at the first char on line one.
			#~ out_text.focus
			#~ out_text.mark_set('insert', '1.0')
		#~ end
	end
}

#
# Set the selection mode for box_list:
#
box_delete_button.bind("Button-1") {

	#
	# Determine the current selectmode configuration, it will be either "extended", only one item
	# selectable at a time, or "multiple", where more than one item at a time can be selected.
	# Switch configuration between the two: "extended" or "multiple".
	#
	case box_list.cget("selectmode")

		when "extended"

			box_list.configure("selectmode", "multiple")
			box_delete_button.configure("text", "Select Multiple")

		when "multiple"

			#
			# User can select (highlight) multiple list elements at once.
			#
			box_list.configure("selectmode", "extended")
			box_delete_button.configure("text", "Select Single")

			#
			# Clear all selected elements, then select (highlight) the last element selected,
			# which is the currently 'active' element - the last one clicked on.
			#
			box_list.selection_clear(0, "end")
			box_list.selection_set(box_list.index("active"))
	end
}

#
# ###########################################################
#
# Menu:
#
#		Read:
#			Read Ruby Code file to create form box list [displaying box numbers].
#
#		Exit:
#			Exit the Application.
#
main_menu = TkMenu.new(root)

read_menu = TkMenu.new(main_menu, :tearoff=>false)

#
#
# This reads the .XML file for a document.
#
read_menu.add('command', :label=> "XML File", :command=> proc {

	tmp_array = Array.new

	#~ fname = get_file_name(cur_dir, "XML")
fname = get_file_name(cur_dir, "ZIP")

	unless (fname.empty?)

		#
		# Set File Label text and clear the out_text area:
		#
		file_name_label.configure("text", fname)
		out_text.delete("1.0", "end")

		cur_dir = File.dirname(fname)
		box_list.delete(0, "end")

		#~ #
		#~ # Now read and process the calculations if there are any:
		#~ #
		#~ calc_box_array = read_ruby_code(fname, set_list.index("active"))

		#~ if (calc_box_array)

			#~ #
			#~ # Sort the array first - easier to look for non $ boxes:
			#~ #
			#~ calc_box_array.join.scan(/(box)(\d+)(_)(\d+)/) do tmp_array.push([$2.to_i,$4.to_i]) end
			#~ tmp_array.sort!

			#~ calc_box_array.clear
			#~ tmp_array.each_index do |index| calc_box_array.push("box#{tmp_array[index][0]}_#{tmp_array[index][1]}") end
			#~ calc_box_array.each { |box| box_list.insert("end", box) }
			#~ process_errors("Attention!", 4, nil) unless (calc_box_array.length > 0)
		#~ end
		box_array = build_box_array_xml(fname)
#~ box_array = build_box_array_xml(fname,out_text)

		#
		# Now insert into the actual box list [TK land].
		#
		box_array.each { |box| box_list.insert('end', box) }
	end
})

main_menu.add('cascade', :menu=>read_menu, :label=>"Read")

profile_menu = TkMenu.new(main_menu, :tearoff=>false)

main_menu.add('command', :label=> "Exit", :command=> proc{exit})

#
# Adding main_menu to the root window.
#
root.menu(main_menu)

Tk.mainloop()
